function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { Dimensions, ScrollView as NativeScroll, StyleSheet, View, Animated } from 'react-native';
import React, { useCallback, useRef, useState, useEffect } from 'react';
const {
  height
} = Dimensions.get('window');
const ScrollView = props => {
  const scroll = useRef(null);
  const scrolAnimation = useRef(new Animated.Value(1)).current;
  const [ScrolledSize, setScrolledSize] = useState(1);
  const animation = useCallback((val, velocity, ch) => {
    Animated.spring(scrolAnimation, {
      toValue: height * (val / ch),
      useNativeDriver: true,
      bounciness: 8,
      velocity,
      delay: 0
    }).start();
  }, [scrolAnimation]);
  const _Scrolled = useCallback(event => {
    setScrolledSize(event.nativeEvent.contentSize.height);
    animation(event.nativeEvent.contentOffset.y, event.nativeEvent.velocity, event.nativeEvent.contentSize.height);
  }, [animation]);
  useEffect(() => {
    const t = setTimeout(() => {
      scroll.current?.scrollTo({
        y: 1
      });
    }, 10);
    return () => clearTimeout(t);
  }, []);
  const indicator = height / (ScrolledSize / height);
  return /*#__PURE__*/React.createElement(View, {
    style: styles.container
  }, /*#__PURE__*/React.createElement(NativeScroll, _extends({}, props, {
    ref: scroll,
    onScroll: _Scrolled,
    onLayout: e => console.log(e.nativeEvent.layout),
    scrollEventThrottle: 70,
    showsVerticalScrollIndicator: false
  }), props.children), /*#__PURE__*/React.createElement(Animated.View, {
    style: styles.indicatorView(indicator, scrolAnimation, props.indicatorColor, props.indicatorWidth, props.indicatorborder)
  }));
};
export default ScrollView;
ScrollView.defaultProps = {
  indicatorborder: 20,
  indicatorColor: '#303030',
  indicatorWidth: 4,
  showAlways: true
};
const styles = StyleSheet.create({
  indicatorView: (height, scrolAnimation, color, width, borderRadius) => ({
    position: 'absolute',
    top: 0,
    right: 0,
    width: width,
    backgroundColor: color,
    height,
    borderRadius,
    transform: [{
      translateY: scrolAnimation
    }]
  }),
  container: {
    flex: 1,
    position: 'relative',
    width: '100%'
  }
});
//# sourceMappingURL=ScrollView.js.map